# 23apr23 Software Lab. Alexander Burger

,"Demo"  "@lib/math.l" "@lib/gis.l" "@lib/canvas.l" "@lib/simul.l"

(symbols 'pico~demo 'simul 'gis 'android 'pico)

(local) (*Picture *QR-Code mkChartData mkDemoTable)

(de mkChartData (I)
   (list
      (bit? 1 I)
      I
      (pack
         (cons
            (char (+ 64 I))
            (need 5 (char (+ 96 I))) ) ) ) )

(de mkDemoTable (Rows)
   (<table> NIL "Chart" '((btn) (align "Number") (NIL "Text"))
      (do 7
         (<row> NIL
            (gui 1 '(+Checkbox))
            (gui 2 '(+Sgn +NumField) 12)
            (gui 3 '(+TextField) 12)
            (gui 4 '(+DelRowButton))
            (gui 5 '(+BubbleButton)) ) ) ) )

(start
   #{(task -3599999 60000  # 1 h / 1 min
      (unless (fork)
         (or
            (info "demo/pil.zip")
            (>=
               (in "demo/version" (line T))
               (ssl "software-lab.de" "demo.version" (line T)) )
            (download "software-lab.de" "demo.zip" "demo/pil.zip") )
         (bye) ) )}#
   (seed (in "/dev/urandom" (rd 8))) )

#{(stop
   (task -3599999) )}#

(overview NIL)
(pilbox
   (<h3> "fh" "Pil Demo")
   (<h4> "fh" "Version " (prin (in "demo/version" (line T)))) )
(menu "Pil Demo"
   (<layout> T
      ((50 15)
         (<div> @
            (<button> "demo/fields.l?*Tab=+1" "Fields") )
         ((50 15)
            (<div> @
               (<button> "demo/charts.l?*Tab=+1" "Charts") ) ) )
      ((50 15)
         (<div> @
            (<button> "demo/canvas.l?*Tab=+1" "Canvas") )
         ((50 15)
            (<div> @
               (<button> "demo/fields.l?*Tab=+3" "Life") ) ) )
      ((50 15)
         (<div> @
            (<button> "demo/camera.l" "Camera") )
         ((50 15)
            (<div> @
               (<button> "demo/scan.l" "Scan") ) ) )
      ((50 15)
         (<div> @
            (<button> "demo/maps.l?*Tab=+1" "GPS") )
         ((50 15)
            (<div> @
               (<button> "demo/notify.l" "Notify") ) ) ) ) )
